﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace TelerikWebApp2
{

    public partial class WebUserControl1 : System.Web.UI.UserControl
    {
        static List<GUIBasicRecipeLocationMessage> s_locationMessages = new List<GUIBasicRecipeLocationMessage>();

        protected void Page_Init(object sender, EventArgs e)
        {
            System.Console.WriteLine("BasicSetupRecipeUC:Page_Init: Page.IsPostback=" + Page.IsPostBack.ToString());
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            System.Console.WriteLine("BasicSetupRecipeUC:Page_Load: Page.IsPostback=" + Page.IsPostBack.ToString());

            if (Page.IsPostBack) return;

            SetupLocationTable();

            for (int i = 0; i < BumpLocationGrid.PageSize; i++)
            {
                BumpLocationGrid.EditIndexes.Add(i);
            }


        }


        protected void SaveButton_Click(object sender, EventArgs e)
        {
            //This may not be called directly as the BatchEdit takes precident.
            System.Console.WriteLine("BasicSetupRecipeUC:SaveButton_Click:");

            //Has the validation been successful?
            if (!Page.IsValid) return;

            DoSaveBasicRecipeSetup();


            SetupLocationTable();

        }
        protected void ResetButton_Click(object sender, EventArgs e)
        {
            //This may not be called directly as the BatchEdit takes precident.
            System.Console.WriteLine("BasicSetupRecipeUC:ResetButton_Click:");

            SetupLocationTable();

        }

        private void DoSaveBasicRecipeSetup()
        {
            System.Console.WriteLine("BasicSetupRecipeUC:DoSaveBasicRecipeSetup:");


        }

        protected void BumpLocationGrid_BatchEditCommand(object sender, GridBatchEditingEventArgs e)
        {
            try
            {
                System.Console.WriteLine("BasicSetupRecipeUC:BumpLocationGrid_BatchEditCommand:");

                foreach (GridBatchEditingCommand command in e.Commands)
                {
                    Hashtable newValues = command.NewValues;
                    Hashtable oldValues = command.OldValues;
#if DEBUG
                    System.Console.WriteLine("BasicSetupRecipeUC:BumpLocationGrid_BatchEditCommand: commands.Item[GUIIndex]=" + command.Item["GUIIndex"].Text
                                    + ", x(old)=" + oldValues["x_coord"] + ", (new)=" + newValues["x_coord"]
                                    + ", y(old)=" + oldValues["y_coord"] + ", (new)=" + newValues["y_coord"]);
#endif
                    int GUIIndex = Convert.ToInt32(command.Item["GUIIndex"].Text);
                    GUIBasicRecipeLocationMessage currentValues = s_locationMessages[GUIIndex];
                    if (newValues["x_coord"] != null)
                    {
                        currentValues.x_coord = (float)Convert.ToDouble(newValues["x_coord"]);
                    }
                    if (newValues["y_coord"] != null)
                    {
                        currentValues.y_coord = (float)Convert.ToDouble(newValues["y_coord"]);
                    }
                }
                DoSaveBasicRecipeSetup();

            }
            catch (Exception ex)
            {
                System.Console.WriteLine("BasicSetupRecipeUC:BumpLocationGrid_BatchEditCommand: Exception:", ex);
            }

            try
            {
                foreach (GridEditableItem editedItem in BumpLocationGrid.EditItems)
                {
                    System.Console.WriteLine("BasicSetupRecipeUC:BumpLocationGrid_BatchEditCommand: EditItems: index=" + editedItem.ItemIndex.ToString());
                    editedItem.Edit = false;
                }
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("BasicSetupRecipeUC:BumpLocationGrid_BatchEditCommand: Clearing EditItems Exception:", ex);
            }
        }

        private void SetupLocationTable()
        {
            if (s_locationMessages.Count == 0)
            {
                s_locationMessages.Add(new GUIBasicRecipeLocationMessage { GUIIndex = 0, x_coord = 0.0F, y_coord = 0.0F, bz = 0.0F, phi = 0.0F, theta = 0.0F });
                s_locationMessages.Add(new GUIBasicRecipeLocationMessage { GUIIndex = 1, x_coord = 1.0F, y_coord = 1.0F, bz = 0.0F, phi = 0.0F, theta = 0.0F });
                s_locationMessages.Add(new GUIBasicRecipeLocationMessage { GUIIndex = 2, x_coord = 2.0F, y_coord = 2.0F, bz = 0.0F, phi = 0.0F, theta = 0.0F });
                s_locationMessages.Add(new GUIBasicRecipeLocationMessage { GUIIndex = 3, x_coord = 3.0F, y_coord = 3.0F, bz = 0.0F, phi = 0.0F, theta = 0.0F });
                s_locationMessages.Add(new GUIBasicRecipeLocationMessage { GUIIndex = 4, x_coord = 4.0F, y_coord = 4.0F, bz = 0.0F, phi = 0.0F, theta = 0.0F });
            }
            BumpLocationGrid.MasterTableView.DataSource = s_locationMessages;
            BumpLocationGrid.Rebind();

        }


    }
}